#include<bits/stdc++.h>
#define maxn 100005
using namespace std;
int a[maxn];
int n;
int k;
int br[10];
int main()
{
	scanf("%d %d",&n,&k);
	for(int i=0;i<n;i++) scanf("%d",&a[i]);
	for(int i=0;i<n;i++) br[a[i]]++;
	int mk=100;
	int s=0;
	for(int i=0;i<=9;i++) {
		s=0;
		for(int j=i;j<=9;j++) {
			s+=br[j];
			if(s+k>=n) mk=min(mk,j*j-i*i);
		}
	}
	printf("%d",mk);
	return 0;
}
